module Admin
  class <%= plural_name.camelize %>Controller < ApplicationController
    include PortalToolkit::Mixins::Pagination
    include PortalToolkit::Mixins::Ordering

    before_action :set_default_sort, only: :index
    helper_method :show_attributes

    def index
      @q = <%= name %>.ransack(params[:q])
      @pagy, @<%= table_name %> = pagy(@q.result)
    end

    def find_resource
      @<%= singular_table_name %> = <%= name %>.find(params[:id])
    end

    def build_resource
      @<%= singular_table_name %> = <%= name %>.new
    end

    def update_resource
      @<%= singular_table_name %>.update(permitted_params)
    end

    def destroy_resource
      @<%= singular_table_name %>.destroy
    end

    def show_attributes
      %i[<%= field_names.join(" ") %>]
    end

    private

    def default_sort
      "id desc"
    end

    def permitted_params
      params.require(:<%= singular_name %>).permit(<%= field_names.map{ |f| ":#{f}"}.join(", ") %>)
    end
  end
end
